Summary:	Object Oriented Script Language
Name:		ruby
Version:	1.8.2
%define		subver 1.8
Release: 	6mdk
License:	GPL
Group:		Development/Other
BuildRequires:	XFree86-devel
BuildRequires:	autoconf2.5
BuildRequires:	byacc
BuildRequires:	ncurses-devel
BuildRequires:	readline-devel
BuildRequires:	tcl tk
BuildRequires:  db4.2-devel
BuildRequires:  libgdbm-devel >= 1.8.3
Obsoletes:	ruby-rexml
Provides:	ruby-rexml

Source0:	ftp://ftp.ruby-lang.org/pub/ruby/ruby-%{version}.tar.bz2
Source1:	http://www.rubycentral.com/faq/rubyfaqall.html.bz2
Source2:	http://dev.rubycentral.com/downloads/files/ProgrammingRuby-0.4.tar.bz2
Patch0:		ruby-1.8.2-lib64.patch.bz2
Patch1:		ruby-1.8.2-do-not-use-system-ruby-to-generate-ri-doc.patch.bz2
URL:		http://www.ruby-lang.org/
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%define my_target_cpu %{_target_cpu}
%ifarch ppc
%define my_target_cpu powerpc
%endif
%ifarch amd64
%define my_target_cpu x86_64
%endif

%package	doc
Summary:	Documentation for the powerful language Ruby
Group:		Development/Other
Requires:	%{name} = %{version}-%{release}

%package	devel
Summary:	Development file for the powerful language Ruby
Group:		Development/Other
Requires:	%{name} = %{version}-%{release}

%package	tk
Summary:	Tk extension for the powerful language Ruby
Group:		Development/Other
Requires:	%{name} = %{version}-%{release}

%description
Ruby is the interpreted scripting language for quick and
easy object-oriented programming.  It has many features to
process text files and to do system management tasks (as in
Perl).  It is simple, straight-forward, and extensible.

%description	doc
Ruby is the interpreted scripting language for quick and
easy object-oriented programming.  It has many features to
process text files and to do system management tasks (as in
Perl). It is simple, straight-forward, and extensible.

This package contains the Ruby's documentation

%description	devel
Ruby is the interpreted scripting language for quick and
easy object-oriented programming.  It has many features to
process text files and to do system management tasks (as in
Perl). It is simple, straight-forward, and extensible.

This package contains the Ruby's devel files.

%description	tk
Ruby is the interpreted scripting language for quick and
easy object-oriented programming.  It has many features to
process text files and to do system management tasks (as in
Perl). It is simple, straight-forward, and extensible.

This package contains the Tk extension for Ruby.

%prep
%setup -q
%patch0 -p0 -b .lib64
%patch1 -p1
sed -i -e "starget_os=`echo $target_os | sed 's/linux-gnu$/linux/;s/linux-gnu/linux-/'`" configure.in

#FILELIST="ruby.1 \
#	 ext/extmk.rb.in \
#	 ext/curses/*.rb \
#	 ext/tcltklib/demo/*.* ext/tcltklib/sample/*.rb ext/tcltklib/*.euc \
#	 ext/tk/sample/*.rb \
#	 sample/*.*"
#for i in ${FILELIST}; do
#	 sed -e s#%{_prefix}/local/bin/#%{_bindir}/#g $i >$i.$$
#	 mv $i.$$ $i
#done

%build
echo '.text' | gcc -shared -o libdummy.so.0 -xassembler - -ltcl -ltk >& /dev/null && {
  if %{_bindir}/ldd libdummy.so.0 | grep -q "lib\(tcl\|tk\).so"; then
    echo "Your tcl/tk is broken, get one with versioning in the libraries."
    exit 1
  fi
  rm -f libdummy.so.0
}

CFLAGS=`echo %optflags | sed 's/-fomit-frame-pointer//'`
%configure2_5x --enable-shared --disable-rpath
%make
make test

%install
rm -rf %buildroot
%makeinstall_std install-doc

install -d %buildroot%{_docdir}/%{name}-%{version}
cp -a COPYING* ChangeLog README* ToDo sample %buildroot%{_docdir}/%{name}-%{version}
bzcat %{SOURCE1} > %buildroot%{_docdir}/%{name}-%{version}/FAQ.html

install -d %buildroot%{_datadir}/emacs/site-lisp
cp -a misc/ruby-mode.el %buildroot%{_datadir}/emacs/site-lisp

install -d %buildroot%{_sysconfdir}/emacs/site-start.d
cat <<EOF >%buildroot%{_sysconfdir}/emacs/site-start.d/%{name}.el
(autoload 'ruby-mode "ruby-mode" "Ruby editing mode." t)
(add-to-list 'auto-mode-alist '("\\\\.rb$" . ruby-mode))
(add-to-list 'interpreter-mode-alist '("ruby" . ruby-mode))
EOF

(cd %buildroot%{_docdir}/%{name}-%{version} ; tar xfj %{SOURCE2} ; cd Pro*; mv -f html/* . ; rm -rf html xml)

(cd %buildroot ; find usr/lib/%{name}/%{subver} ! -type d -printf "/%%p\n") > %{name}.list
(cd %buildroot ; find usr/lib/%{name}/%{subver}   -type d -printf "%%%%dir /%%p\n") >> %{name}.list

perl -ni -e 'print if !m|/(tcl)?tk|' %{name}.list
perl -ni -e 'print if !m|%{my_target_cpu}-%{_host_os}/.*[ha]$|' %{name}.list

%clean
rm -rf %buildroot

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files -f %{name}.list
%defattr(-, root, root)
%dir %{_docdir}/%{name}-%{version}
%{_docdir}/%{name}-%{version}/README
%{_bindir}/*
%dir %{_prefix}/lib/%{name}/
%{_libdir}/libruby.so.*
%{_prefix}/lib/%{name}/site_ruby
%{_mandir}/*/*
%{_datadir}/emacs/site-lisp/*
%config(noreplace) %{_sysconfdir}/emacs/site-start.d/*

%files doc
%defattr(-, root, root)
%{_datadir}/ri
%{_docdir}/%{name}-%{version}/COPYING*
%{_docdir}/%{name}-%{version}/ChangeLog
%{_docdir}/%{name}-%{version}/README.*
%{_docdir}/%{name}-%{version}/FAQ.html
%{_docdir}/%{name}-%{version}/ToDo
%{_docdir}/%{name}-%{version}/sample
%{_docdir}/%{name}-%{version}/ProgrammingRuby*

%files devel
%defattr(-, root, root)
%{_prefix}/lib/%{name}/%{subver}/%{my_target_cpu}-%{_host_os}/*.[ah]
%{_libdir}/libruby-static.a
%{_libdir}/libruby.so

%files tk
%defattr(-, root, root)
%{_prefix}/lib/%{name}/%{subver}/%{my_target_cpu}-%{_host_os}/tcltk*
%{_prefix}/lib/%{name}/%{subver}/%{my_target_cpu}-%{_host_os}/tk*
%{_prefix}/lib/%{name}/%{subver}/tcltk*
%{_prefix}/lib/%{name}/%{subver}/tk*
%{_prefix}/lib/%{name}/%{subver}/test/unit/ui/tk

%changelog
* Wed Mar 30 2005 Pascal Terjan <pterjan@mandrake.org> 1.8.2-6mdk
- put and search everything in %%{_prefix}/lib/ruby/ even on x86_64, else all
  noarch packages won't work

* Fri Jan 21 2005 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 1.8.2-5mdk
- rebuild for new readline

* Tue Jan 18 2005 Gtz Waschk <waschk@linux-mandrake.com> 1.8.2-4mdk
- force build with libgdbm3

* Sat Jan 15 2005 Pixel <pixel@mandrakesoft.com> 1.8.2-3mdk
- add ri doc (bugzilla #12976)

* Sun Jan  2 2005 Pascal Terjan <pterjan@mandrake.org> 1.8.2-2mdk
- Disable rpath

* Fri Dec 31 2004 Pascal Terjan <pterjan@mandrake.org> 1.8.2-1mdk
- 1.8.2

* Wed Dec  8 2004 Götz Waschk <waschk@linux-mandrake.com> 1.8.1-5mdk
- rebuild for libgdbm3

* Mon Aug 30 2004 Götz Waschk <waschk@linux-mandrake.com> 1.8.1-4mdk
- build with db 4.2

* Mon Jun 28 2004 Christiaan Welvaart <cjw@daneel.dyndns.org> 1.8.1-2mdk
- BuildRequires: tcl

* Sun Dec 14 2003 Pascal Terjan <pterjan@mandrake.org> 1.8.1-1mdk
- 1.8.1 

* Mon Nov 10 2003 Pixel <pixel@mandrakesoft.com> 1.8.0-7mdk
- add libruby.so to ruby-devel (thanks to Pascal Terjan)

* Thu Nov  6 2003 Pixel <pixel@mandrakesoft.com> 1.8.0-6mdk
- rebuild with --enable-shared

* Sat Oct 25 2003 Stefan van der Eijk <stefan@eijk.nu> 1.8.0-5mdk
- BuildRequires

* Mon Sep  8 2003 Pixel <pixel@mandrakesoft.com> 1.8.0-4mdk
- Obsoletes/Provides ruby-rexml (thanks to Pascal Terjan)

* Thu Aug 14 2003 Pixel <pixel@mandrakesoft.com> 1.8.0-3mdk
- distlint DIRM fix: add %{_prefix}/lib/ruby/site_ruby down to /usr/lib/ruby/site_ruby/1.8/i586-linux-gnu

* Wed Aug  6 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.8.0-2mdk
- handle amd64 alias

* Wed Aug  6 2003 Pixel <pixel@mandrakesoft.com> 1.8.0-1mdk
- new release

* Tue Jun 17 2003 Stefan van der Eijk <stefan@eijk.nu> 1.6.8-3mdk
- BuildRequires

* Tue Apr 22 2003 Pixel <pixel@mandrakesoft.com> 1.6.8-2mdk
- rebuild for tcl/tk 8.4

* Sat Dec 28 2002 Pixel <pixel@mandrakesoft.com> 1.6.8-1mdk
- new release
- update ProgrammingRuby doc
- update rubyfaqall (and also update the url to get it)

* Wed Nov  6 2002 Stefan van der Eijk <stefan@eijk,nu> 1.6.7-6mdk
- BuildRequires: byacc

* Sat Nov  2 2002 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.6.7-5mdk
- Patch0: Add support for lib64 platforms
- Patch1: Add missing includes and don't explicitly -I%{_prefix}/include
- Patch2: Fix support of 64-bit platforms, mostly with varargs

* Wed Jul 24 2002 Pixel <pixel@mandrakesoft.com> 1.6.7-4mdk
- really rebuild for new readline

* Tue Jul 23 2002 Pixel <pixel@mandrakesoft.com> 1.6.7-3mdk
- rebuild for new readline

* Thu May 30 2002 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.6.7-2mdk
- Ah, turns out to be built with gcc3.1 too
- Don't test for versioned tcl/tk libraries by name. There could be ld
  scripts instead. Anyway, tcl/tk looks broken since they don't have
  any SONAME.

* Tue Mar 19 2002 Pixel <pixel@mandrakesoft.com> 1.6.7-1mdk
- new release

* Thu Feb 28 2002 Geoffrey Lee <snailtalk@mandrakesoft.com> 1.6.6-2mdk
- Recompile to get versioned tcl/tk linking.

* Thu Dec 27 2001 Pixel <pixel@mandrakesoft.com> 1.6.6-1mdk
- new version

* Fri Oct  5 2001 Pixel <pixel@mandrakesoft.com> 1.6.5-1mdk
- new version

* Mon Jul 23 2001 Pixel <pixel@mandrakesoft.com> 1.6.4-2mdk
- don't mess CFLAGS, just remove fomit-frame-pointer

* Mon Jun  4 2001 Pixel <pixel@mandrakesoft.com> 1.6.4-1mdk
- new version

* Fri May 25 2001 Pixel <pixel@mandrakesoft.com> 1.6.3-4mdk
- directories-are-not-executables

* Fri May 18 2001 Pixel <pixel@mandrakesoft.com> 1.6.3-3mdk
- fix dadou fucking up things (irb and emacs mode were not there anymore!)

* Fri Apr 20 2001 David BAUDENS <baudens@mandrakesoft.com> 1.6.3-2mdk
- Fix build on PPC

* Sun Mar 25 2001 Pixel <pixel@mandrakesoft.com> 1.6.3-1mdk
- new version

* Mon Mar 19 2001 Pixel <pixel@mandrakesoft.com> 1.6.2.2-2mdk
- fix the ruby.el (\\. -> \\\\.)

* Thu Jan 25 2001 Pixel <pixel@mandrakesoft.com> 1.6.2.2-1mdk
- new stable snapshot

* Wed Dec 27 2000 Pixel <pixel@mandrakesoft.com> 1.6.2-2mdk
- fix extensions
- create %{name}-devel
- remove %{name}-extensions, but create %{name}-tk

* Tue Dec 26 2000 Pixel <pixel@mandrakesoft.com> 1.6.2-1mdk
- new version

* Mon Nov 27 2000 Pixel <pixel@mandrakesoft.com> 1.6.1-4mdk
- build again full optflags

* Wed Nov  8 2000 Pixel <pixel@mandrakesoft.com> 1.6.1-3mdk
- build without -fomit-frame-pointer for time being
- capitalize summaries

* Mon Oct  2 2000 Pixel <pixel@mandrakesoft.com> 1.6.1-2mdk
- fix mispelling

* Thu Sep 28 2000 Pixel <pixel@mandrakesoft.com> 1.6.1-1mdk
- new version
- remove "--with-default-kcode=none", not more needed
- remove setting optflags to -O2, ruby doesn't crashes any more

* Tue Sep 19 2000 Pixel <pixel@mandrakesoft.com> 1.6.0-1mdk
- new version

* Wed Aug 23 2000 Pixel <pixel@mandrakesoft.com> 1.4.6-6mdk
- add packager

* Tue Aug 22 2000 Pixel <pixel@mandrakesoft.com> 1.4.6-5mdk
- nicer site-start.d/ruby.el (use add-to-list)

* Tue Aug 22 2000 Pixel <pixel@mandrakesoft.com> 1.4.6-4mdk
- fix missing %%config

* Tue Aug 22 2000 Pixel <pixel@mandrakesoft.com> 1.4.6-3mdk
- use %{_sysconfdir}/emacs/site-start.d for the ruby-mode.el

* Fri Aug 18 2000 Pixel <pixel@mandrakesoft.com> 1.4.6-2mdk
- rebuild (fredlsux)

* Fri Aug 18 2000 Pixel <pixel@mandrakesoft.com> 1.4.6-1mdk
- new version
- remove menu

* Mon Aug 07 2000 Frederic Lepied <flepied@mandrakesoft.com> 1.4.5-6mdk
- automatically added BuildRequires

* Wed Jul 19 2000 Pixel <pixel@mandrakesoft.com> 1.4.5-5mdk
- rebuild with clean clean_menus

* Wed Jul 19 2000 Pixel <pixel@mandrakesoft.com> 1.4.5-4mdk
- macroization
- BM

* Thu Jul 13 2000 Pixel <pixel@mandrakesoft.com> 1.4.5-3mdk
- fix %%URL

* Sun Jun 25 2000 Pixel <pixel@mandrakesoft.com> 1.4.5-2mdk
- rebuild (src.rpm got lost :( )

* Fri Jun 23 2000 Pixel <pixel@mandrakesoft.com> 1.4.5-1mdk
- new version

* Wed Jun 14 2000 Pixel <pixel@mandrakesoft.com> 1.4.4-1mdk
- new version

* Mon Apr 10 2000 Pixel <pixel@mandrakesoft.com> 1.4.3-6mdk
- fix group for doc

* Mon Mar 27 2000 Pixel <pixel@mandrakesoft.com> 1.4.3-5mdk
- add menu

* Sat Mar 25 2000 Pixel <pixel@mandrakesoft.com> 1.4.3-4mdk
- new group + cleanup

* Wed Feb 16 2000 Pixel <pixel@mandrakesoft.com> 1.4.3-3mdk
- build with no charset conversion (was kanji :)

* Mon Feb 14 2000 Pixel <pixel@mandrakesoft.com> 1.4.3-2mdk
- added the reference manual and FAQ in doc
- moved the lib/README in ext

* Mon Feb 14 2000 Pixel <pixel@mandrakesoft.com> 1.4.3-1mdk
- mandrake adaptation and spliting in -/doc/extensions

* Wed Dec 08 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- Updated to version 1.4.3

* Mon Sep 20 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- Updated to version 1.4.2 (Sep 18)

* Fri Sep 17 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- Updated to version 1.4.2

* Tue Aug 17 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- Updated to version 1.4.0

* Fri Jul 23 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- 2nd release
- Updated to version 1.2.6(15 Jul 1999)
- striped %{prefix}/bin/ruby

* Mon Jun 28 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- Updated to version 1.2.6(21 Jun 1999)

* Wed Apr 14 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- Updated to version 1.2.5

* Fri Apr 09 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- Updated to version 1.2.4

* Fri Dec 25 1998 Toru Hoshina <hoshina@best.com>
- Version up to 1.2 stable.

* Fri Nov 27 1998 Toru Hoshina <hoshina@best.com>
- Version up to 1.1c9.

* Thu Nov 19 1998 Toru Hoshina <hoshina@best.com>
- Version up to 1.1c8, however it appear short life :-P

* Fri Nov 13 1998 Toru Hoshina <hoshina@best.com>
- Version up.

end of changelog shortened, hope you japs won't kill a froggy for this :)
